// Filled in by database
var switchstatus = 0
var astralstatus = 0
var connstatus = 0
var lastupdate = 0
var devicekey = 0

// Fill in manually
var apiurl = ''
var srvkey = ''
var deviceurl = ''
var deviceid =


    setInterval(getstatus, 1000);

function getstatus_init() {
    var request = new XMLHttpRequest();
    request.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            var response = JSON.parse(request.responseText)
            setswitchstatus(response)
            setastralstatus(response)
            setconnstatus(response)
            setpagevars(response)
            createmap(response.loc_lat, response.loc_lon);
            retrievelogs()
        }
    }
    request.open('POST', apiurl+'/fullstatus?id=1&apikey='+srvkey, true);
    request.send();
}

function getstatus() {
    var request = new XMLHttpRequest();
    request.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            var response = JSON.parse(request.responseText)
            setswitchstatus(response)
            setastralstatus(response)
            setconnstatus(response)
        }
    }
    request.open('POST', apiurl+'/fullstatus?id=1&apikey='+srvkey, true);
    request.send();
}

function updatelocation() {
    var request = new XMLHttpRequest();
    request.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            var response = JSON.parse(request.responseText)
            setpagevars(response)
        }
    }
    request.open('POST', apiurl+'/fullstatus?id=1&apikey=apikey='+srvkey, true);
    request.send();
}

function setswitchstatus(response) {
    var elements = document.getElementsByClassName('switchedgecolor')
    var button = document.getElementById('switchbtn')
    if (response.switch_status == 1) {
        changeedgecolor('gold', button, elements)
        switchstatus = 1
    } else if (response.switch_status == 0) {
        changeedgecolor('grey', button, elements)
        switchstatus = 0
    }
}

function setastralstatus(response) {
    var elements = document.getElementsByClassName('astraledgecolor')
    var button = document.getElementById('astralbtn')
    if (response.astral_status == 1) {
        changeedgecolor('blue', button, elements)
        astralstatus = 1
    } else if (response.astral_status == 0) {
        changeedgecolor('grey', button, elements)
        astralstatus = 0
    }
}

function setconnstatus(response) {
    var elements = document.getElementsByClassName('connedgecolor')
    var button = document.getElementById('connbtn')
    if (response.conn_status == 1) {
        changeedgecolor('green', button, elements)
        connstatus = 1
    } else if (response.conn_status == 0) {
        changeedgecolor('red', button, elements)
        connstatus = 0
    }
}

function setpagevars(response) {
    document.getElementById('subtitle').innerHTML = "Last update: " + response.last_updated
    document.getElementById('pagetitle').innerHTML = "PiSwitch Dashboard " + response.switch_name
    document.getElementById('turnontime').setAttribute('value', response.on_time)
    document.getElementById('turnofftime').setAttribute('value', response.off_time)
    document.getElementById('loc_name').setAttribute('value', response.loc_name)
    document.getElementById('loc_region').setAttribute('value', response.loc_region)
    document.getElementById('loc_lat').setAttribute('value', response.loc_lat)
    document.getElementById('loc_lon').setAttribute('value', response.loc_lon)
    devicekey = response.apikey

    var elements = document.getElementsByClassName('srvkey')
    for (var i = 0, len = elements.length; i < len; i++) {
        elements[i].setAttribute('value', srvkey)
    }
}

function toggleswitch() {
    var request = new XMLHttpRequest();
    request.open('POST', deviceurl+deviceid+'/override?apikey='+devicekey, true);
    request.send();
}

function retrievelogs() {
    var request = new XMLHttpRequest();
    request.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            var response = JSON.parse(request.responseText)
            logtable(response)
        }
    }
    request.open('GET', apiurl+'/cmd?id=1&apikey='+srvkey, true);
    request.send();

}

function toggleastral() {
    if (astralstatus == 0) {
        var request = new XMLHttpRequest();
        request.open('POST', deviceurl+deviceid+'/toggleastral?command=1&apikey='+devicekey, true);
        request.send();
    } else if (astralstatus == 1) {
        var request = new XMLHttpRequest();
        request.open('POST', deviceurl+deviceid+'/toggleastral?command=0&apikey='+devicekey, true);
        request.send();
    }
}

function changeedgecolor(color, button, elements) {
    for (var i = 0, len = elements.length; i < len; i++) {
        elements[i].classList.add('class', color + 'edgecolor')
        if (color != 'grey') {
            elements[i].classList.remove('class', 'greyedgecolor')
        }
        button.src = 'assets/img/power-button-' + color + '.svg'
    }
}

// function logtable(response) {
//     for (i = 0; i < Object.keys(response).length; i++) {
//         var tablecontent = tablecontent + '<tr><td class="tg-mk6l">' + response[i]['date'] + '</td><td class="tg-mk6l">' + response[i]['command'] + '</td></tr>';
//     }
//     document.getElementById('log').innerHTML = tablecontent;
// }
