function createmap(lat, lon) {
    if (switchstatus == 0) {
        color = '#333333'
    } else if (switchstatus == 1) {
        color = '#ffd700'
    }

    L.mapquest.key = '';

    var map = L.mapquest.map('map', {
        center: [lat, lon],
        layers: L.mapquest.tileLayer('dark'),
        zoom: 14
    }).on('click', function (e) {
        addMarker(e);
    });
    var locmarker = L.mapquest.textMarker([lat, lon], {

        type: 'marker',
        icon: {
            primaryColor: '#333333',
            secondaryColor: color,
            size: 'sm'
        }
    }).addTo(map);

    function addMarker(e) {
        updatelocform(e.latlng.wrap())
        locmarker.setLatLng(e.latlng)
    }

    function updatelocform(ll) {
        document.getElementById('loc_lat').setAttribute('value', ll.lat)
        document.getElementById('loc_lon').setAttribute('value', ll.lng)
    }

}

